package dao;


import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;



/**Classe reponsável pela conexão com banco de dados.
 *
 * @author Tomassoni
 */
public class DBConnection {

 

    /*Metodo responsável por retornar a conexão com banco de dados.
     *
     *@param String properties - Arquivo de propriedades contendo as informções
     * necessárias para conexão com banco.
     *@return Connection  - O resultado é o objeto connection para o bando de dados,
     * é a conexão.
     *@throws Exception/Excessão - Caso ocorra erro com a conexão com banco.
     *
     */
    public synchronized Connection getDatabaseConnection() throws ClassNotFoundException, SQLException {
        //setDatabaseAttributes(properties);
        Class.forName("org.hsqldb.jdbcDriver");
        //return DriverManager.getConnection(m_sUrl, m_sUser, m_sPassword);
        String curentPath = System.getProperty("user.dir") + "/";
        curentPath = curentPath.replace('\\', '/');
        //System.out.println("Pesquisando bd:"+ curentPath);
        // Win -> D:/Projetos/Projeto NFE/StatusNfe/NFeConsultaStatus/bd
        // Lin -> /usr/local/nagios/libexec/nfeStatus/bd
        return DriverManager.getConnection("jdbc:hsqldb:file:".concat(curentPath).concat("/bd/nfeStatus;shutdown=true"), "sa", "0x81");
    }   
  
}
