package dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**Classe reponsável por criar a conexão com banco Hsqldb.
 *
 * @author Tomassoni
 */
public class HsqlDAOFactory {
    /*Metodo responsável criar a conexão com banco de dados.
     *
     * @return Connection dbConnection.getDatabaseConnection -
     * O resultado de retorno é a conexão com banco.
     *
     */

    public synchronized static Connection createConnection() {
        DBConnection dbConnection = new DBConnection();
        try {
            return dbConnection.getDatabaseConnection();
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(HsqlDAOFactory.class.getName()).log(Level.SEVERE, "Erro com a conenxão.", ex);
        } catch (SQLException ex) {
            Logger.getLogger(HsqlDAOFactory.class.getName()).log(Level.SEVERE, "Erro com SQL.", ex);
        }
        return null;
    }
}
