/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package nfeconsultastatus;

import br.inf.portalfiscal.www.nfe.wsdl.nfestatusservico2.NfeStatusServico2Stub;
import java.io.StringReader;
import java.net.URL;
import java.security.Security;
import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.util.AXIOMUtil;
import org.apache.commons.digester.Digester;

/**
 *
 * @author http://www.javac.com.br/jc/posts/list/15.page
 * Modifiquei pequenos trechos para ajuste.
 */
public class NFeConsultaStatusServico {

    public static void consultaStatus(String codigoDoEstado, String sUrl, String caminhoDoCertificadoDoCliente,
            String senhaDoCertificadoDoCliente, String arquivoCacertsGeradoParaCadaEstado) {
        try {
            /**
             * 1) codigoDoEstado = Código do Estado conforme tabela IBGE.
             *
             * 2) url = Endereço do WebService para cada Estado.
             *       Ver relação dos endereços em:
             *       Para Homologação: http://hom.nfe.fazenda.gov.br/PORTAL/WebServices.aspx
             *       Para Produção: http://www.nfe.fazenda.gov.br/portal/WebServices.aspx
             *
             * 3) caminhoDoCertificadoDoCliente = Caminho do Certificado do Cliente (A1).
             *
             * 4) senhaDoCertificadoDoCliente = Senha do Certificado A1 do Cliente.
             *
             * 5) arquivoCacertsGeradoParaCadaEstado = Arquivo com os Certificados necessarios para
             * acessar o WebService. Pode ser gerado com a Classe NFeBuildCacerts.
             */
            //String codigoDoEstado = "35";
            URL url = new URL(sUrl);
            //String caminhoDoCertificadoDoCliente = "C:/certificados/fw1.pfx";
            //String senhaDoCertificadoDoCliente = "furacaoadm";
            //String arquivoCacertsGeradoParaCadaEstado = "D:/Projetos/Projeto NFE/StatusNfe/StatusNFe/NFeCacerts";
            /**
             * Informações do Certificado Digital.
             */
            System.setProperty("java.protocol.handler.pkgs", "com.sun.net.ssl.internal.www.protocol");
            Security.addProvider(new com.sun.net.ssl.internal.ssl.Provider());

            System.setProperty("javax.net.ssl.keyStoreType", "PKCS12");

            System.clearProperty("javax.net.ssl.keyStore");
            System.clearProperty("javax.net.ssl.keyStorePassword");
            System.clearProperty("javax.net.ssl.trustStore");

            System.setProperty("javax.net.ssl.keyStore", caminhoDoCertificadoDoCliente);
            System.setProperty("javax.net.ssl.keyStorePassword", senhaDoCertificadoDoCliente);

            System.setProperty("javax.net.ssl.trustStoreType", "JKS");
            System.setProperty("javax.net.ssl.trustStore", arquivoCacertsGeradoParaCadaEstado);

            /**
             * Xml de Consulta.
             */
            StringBuilder xml = new StringBuilder();
            xml.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>").append("<consStatServ versao=\"2.00\" xmlns=\"http://www.portalfiscal.inf.br/nfe\">").append("<tpAmb>1</tpAmb>").append("<cUF>").append(codigoDoEstado).append("</cUF>").append("<xServ>STATUS</xServ>").append("</consStatServ>");

            OMElement ome = AXIOMUtil.stringToOM(xml.toString());
            NfeStatusServico2Stub.NfeDadosMsg dadosMsg = new NfeStatusServico2Stub.NfeDadosMsg();
            dadosMsg.setExtraElement(ome);

            NfeStatusServico2Stub.NfeCabecMsg nfeCabecMsg = new NfeStatusServico2Stub.NfeCabecMsg();
            /**
             * Código do Estado.
             */
            nfeCabecMsg.setCUF(codigoDoEstado);

            /**
             * Versao do XML
             */
            nfeCabecMsg.setVersaoDados("2.00");
            NfeStatusServico2Stub.NfeCabecMsgE nfeCabecMsgE = new NfeStatusServico2Stub.NfeCabecMsgE();
            nfeCabecMsgE.setNfeCabecMsg(nfeCabecMsg);

            NfeStatusServico2Stub stub = null;
            NfeStatusServico2Stub.NfeStatusServicoNF2Result result = null;
            stub = new NfeStatusServico2Stub(url.toString());
            result = stub.nfeStatusServicoNF2(dadosMsg, nfeCabecMsgE);
            Digester digest = new Digester();
            digest.setValidating(false);
            digest.addObjectCreate("retConsStatServ", retConsStatServ.class);

            //digest.addBeanPropertySetter( "retConsStatServ/matches", "matches" );
            //digest.addBeanPropertySetter("retConsStatServ/tpAmb", "tpAmb");
            //digest.addBeanPropertySetter("retConsStatServ/verAplic", "verAplic");
            digest.addBeanPropertySetter("retConsStatServ/tMed", "tMed");

            digest.addBeanPropertySetter("retConsStatServ/xMotivo", "xMotivo");
            retConsStatServ status = (retConsStatServ) digest.parse(new StringReader(result.getExtraElement().toString()));

            System.out.println(status.getxMotivo().concat(" - Tempo medio: ").concat(status.gettMed()));
        } catch (Exception ex) {
            // Suprimi as mensagens de erro.
            System.out.println("Time out");
            //System.out.println(ex);
        }
    }
}
